# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventHub::Mgmt::V2017_04_01
  module Models
    #
    # Single item in List or Get Alias(Disaster Recovery configuration)
    # operation
    #
    class ArmDisasterRecovery < Resource

      include MsRestAzure

      # @return [ProvisioningStateDR] Provisioning state of the Alias(Disaster
      # Recovery configuration) - possible values 'Accepted' or 'Succeeded' or
      # 'Failed'. Possible values include: 'Accepted', 'Succeeded', 'Failed'
      attr_accessor :provisioning_state

      # @return [String] ARM Id of the Primary/Secondary eventhub namespace
      # name, which is part of GEO DR pairing
      attr_accessor :partner_namespace

      # @return [String] Alternate name specified when alias and namespace
      # names are same.
      attr_accessor :alternate_name

      # @return [RoleDisasterRecovery] role of namespace in GEO DR - possible
      # values 'Primary' or 'PrimaryNotReplicating' or 'Secondary'. Possible
      # values include: 'Primary', 'PrimaryNotReplicating', 'Secondary'
      attr_accessor :role

      # @return [Integer] Number of entities pending to be replicated.
      attr_accessor :pending_replication_operations_count


      #
      # Mapper for ArmDisasterRecovery class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ArmDisasterRecovery',
          type: {
            name: 'Composite',
            class_name: 'ArmDisasterRecovery',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'Enum',
                  module: 'ProvisioningStateDR'
                }
              },
              partner_namespace: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.partnerNamespace',
                type: {
                  name: 'String'
                }
              },
              alternate_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.alternateName',
                type: {
                  name: 'String'
                }
              },
              role: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.role',
                type: {
                  name: 'Enum',
                  module: 'RoleDisasterRecovery'
                }
              },
              pending_replication_operations_count: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.pendingReplicationOperationsCount',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
