# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventHub::Mgmt::V2017_04_01
  module Models
    #
    # Properties to configure capture description for eventhub
    #
    class CaptureDescription

      include MsRestAzure

      # @return [Boolean] A value that indicates whether capture description is
      # enabled.
      attr_accessor :enabled

      # @return [EncodingCaptureDescription] Enumerates the possible values for
      # the encoding format of capture description. Note: 'AvroDeflate' will be
      # deprecated in New API Version. Possible values include: 'Avro',
      # 'AvroDeflate'
      attr_accessor :encoding

      # @return [Integer] The time window allows you to set the frequency with
      # which the capture to Azure Blobs will happen, value should between 60
      # to 900 seconds
      attr_accessor :interval_in_seconds

      # @return [Integer] The size window defines the amount of data built up
      # in your Event Hub before an capture operation, value should be between
      # 10485760 to 524288000 bytes
      attr_accessor :size_limit_in_bytes

      # @return [Destination] Properties of Destination where capture will be
      # stored. (Storage Account, Blob Names)
      attr_accessor :destination

      # @return [Boolean] A value that indicates whether to Skip Empty Archives
      attr_accessor :skip_empty_archives


      #
      # Mapper for CaptureDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CaptureDescription',
          type: {
            name: 'Composite',
            class_name: 'CaptureDescription',
            model_properties: {
              enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enabled',
                type: {
                  name: 'Boolean'
                }
              },
              encoding: {
                client_side_validation: true,
                required: false,
                serialized_name: 'encoding',
                type: {
                  name: 'Enum',
                  module: 'EncodingCaptureDescription'
                }
              },
              interval_in_seconds: {
                client_side_validation: true,
                required: false,
                serialized_name: 'intervalInSeconds',
                constraints: {
                  InclusiveMaximum: 900,
                  InclusiveMinimum: 60
                },
                type: {
                  name: 'Number'
                }
              },
              size_limit_in_bytes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sizeLimitInBytes',
                constraints: {
                  InclusiveMaximum: 524288000,
                  InclusiveMinimum: 10485760
                },
                type: {
                  name: 'Number'
                }
              },
              destination: {
                client_side_validation: true,
                required: false,
                serialized_name: 'destination',
                type: {
                  name: 'Composite',
                  class_name: 'Destination'
                }
              },
              skip_empty_archives: {
                client_side_validation: true,
                required: false,
                serialized_name: 'skipEmptyArchives',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
